import {
  APP_LOAD,
  REDIRECT,
  RELOAD,
  REDIRECT_TO,
  COMPONENT,
  CALLBACK_FAIL,
  CALLBACK_SUCCESS,
  ME,
  USER_API,
  CALLBACK_PRIORITY
} from "actions/actionType";
const defaultState = {
  me: {},
  isSuccess: false,
  isFail: false,
  isLoading: false,
  isOutOfRange: false,
  message: ""
};

export default (state = defaultState, action) => {
  switch (action.type) {
    case APP_LOAD:
      return {
        ...state,
        appLoaded: action.appLoaded,
        redirectTo: action.redirectTo
      };
    case REDIRECT:
      return {
        ...state,
        redirectTo: null,
        previousRoute: action.previousRoute
      };
    case REDIRECT_TO:
      return { ...state, redirectTo: action.redirectTo, query: action.query };
    case RELOAD:
      return { ...state, reload: action.reload };
    case COMPONENT.CALLBACK_SUCCESS:
      return { ...state, isSuccess: true };
    case COMPONENT.CALLBACK_LOADING:
      return { ...state, isLoading: true };
    case COMPONENT.CALLBACK_FAIL:
      return { ...state, isFail: true, message: action.data };
    case COMPONENT.CALLBACK_PRIORITY:
      return { ...state, priority: true };
    case COMPONENT.CALLBACK_CLEAR:
      return { ...state, priority: false };
    case COMPONENT.CALLBACK_OUT:
      return {
        ...state,
        isOutOfRange: true,
        isSuccess: false,
        isFail: false,
        isLoading: false
      };
    case COMPONENT.SUCCESS:
      return {
        ...state,
        isLoading: false,
        isSuccess: false,
        isFail: false,
        isOutOfRange: false,
        message: ""
      };
    case USER_API.ME.GET.SUCCESS:
      return {
        ...state,
        me: action.data
      };
    default:
      return state;
  }
};
